<?php

namespace ArrayType;

use \WsdlToPhp\PackageBase\AbstractStructArrayBase;

/**
 * This class stands for ArrayOfServiceTimeTachoDetail ArrayType
 * @subpackage Arrays
 */
class ArrayOfServiceTimeTachoDetail extends AbstractStructArrayBase
{
    /**
     * The ServiceTimeTachoDetail
     * Meta information extracted from the WSDL
     * - maxOccurs: unbounded
     * - minOccurs: 0
     * - nillable: true
     * @var \StructType\ServiceTimeTachoDetail[]
     */
    public $ServiceTimeTachoDetail;
    /**
     * Constructor method for ArrayOfServiceTimeTachoDetail
     * @uses ArrayOfServiceTimeTachoDetail::setServiceTimeTachoDetail()
     * @param \StructType\ServiceTimeTachoDetail[] $serviceTimeTachoDetail
     */
    public function __construct(array $serviceTimeTachoDetail = array())
    {
        $this
            ->setServiceTimeTachoDetail($serviceTimeTachoDetail);
    }
    /**
     * Get ServiceTimeTachoDetail value
     * An additional test has been added (isset) before returning the property value as
     * this property may have been unset before, due to the fact that this property is
     * removable from the request (nillable=true+minOccurs=0)
     * @return \StructType\ServiceTimeTachoDetail[]|null
     */
    public function getServiceTimeTachoDetail()
    {
        return isset($this->ServiceTimeTachoDetail) ? $this->ServiceTimeTachoDetail : null;
    }
    /**
     * This method is responsible for validating the values passed to the setServiceTimeTachoDetail method
     * This method is willingly generated in order to preserve the one-line inline validation within the setServiceTimeTachoDetail method
     * @param array $values
     * @return string A non-empty message if the values does not match the validation rules
     */
    public static function validateServiceTimeTachoDetailForArrayConstraintsFromSetServiceTimeTachoDetail(array $values = array())
    {
        $message = '';
        $invalidValues = [];
        foreach ($values as $arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem) {
            // validation for constraint: itemType
            if (!$arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem instanceof \StructType\ServiceTimeTachoDetail) {
                $invalidValues[] = is_object($arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem) ? get_class($arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem) : sprintf('%s(%s)', gettype($arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem), var_export($arrayOfServiceTimeTachoDetailServiceTimeTachoDetailItem, true));
            }
        }
        if (!empty($invalidValues)) {
            $message = sprintf('The ServiceTimeTachoDetail property can only contain items of type \StructType\ServiceTimeTachoDetail, %s given', is_object($invalidValues) ? get_class($invalidValues) : (is_array($invalidValues) ? implode(', ', $invalidValues) : gettype($invalidValues)));
        }
        unset($invalidValues);
        return $message;
    }
    /**
     * Set ServiceTimeTachoDetail value
     * This property is removable from request (nillable=true+minOccurs=0), therefore
     * if the value assigned to this property is null, it is removed from this object
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceTimeTachoDetail[] $serviceTimeTachoDetail
     * @return \ArrayType\ArrayOfServiceTimeTachoDetail
     */
    public function setServiceTimeTachoDetail(array $serviceTimeTachoDetail = array())
    {
        // validation for constraint: array
        if ('' !== ($serviceTimeTachoDetailArrayErrorMessage = self::validateServiceTimeTachoDetailForArrayConstraintsFromSetServiceTimeTachoDetail($serviceTimeTachoDetail))) {
            throw new \InvalidArgumentException($serviceTimeTachoDetailArrayErrorMessage, __LINE__);
        }
        if (is_null($serviceTimeTachoDetail) || (is_array($serviceTimeTachoDetail) && empty($serviceTimeTachoDetail))) {
            unset($this->ServiceTimeTachoDetail);
        } else {
            $this->ServiceTimeTachoDetail = $serviceTimeTachoDetail;
        }
        return $this;
    }
    /**
     * Add item to ServiceTimeTachoDetail value
     * @throws \InvalidArgumentException
     * @param \StructType\ServiceTimeTachoDetail $item
     * @return \ArrayType\ArrayOfServiceTimeTachoDetail
     */
    public function addToServiceTimeTachoDetail(\StructType\ServiceTimeTachoDetail $item)
    {
        // validation for constraint: itemType
        if (!$item instanceof \StructType\ServiceTimeTachoDetail) {
            throw new \InvalidArgumentException(sprintf('The ServiceTimeTachoDetail property can only contain items of type \StructType\ServiceTimeTachoDetail, %s given', is_object($item) ? get_class($item) : (is_array($item) ? implode(', ', $item) : gettype($item))), __LINE__);
        }
        $this->ServiceTimeTachoDetail[] = $item;
        return $this;
    }
    /**
     * Returns the current element
     * @see AbstractStructArrayBase::current()
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function current()
    {
        return parent::current();
    }
    /**
     * Returns the indexed element
     * @see AbstractStructArrayBase::item()
     * @param int $index
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function item($index)
    {
        return parent::item($index);
    }
    /**
     * Returns the first element
     * @see AbstractStructArrayBase::first()
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function first()
    {
        return parent::first();
    }
    /**
     * Returns the last element
     * @see AbstractStructArrayBase::last()
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function last()
    {
        return parent::last();
    }
    /**
     * Returns the element at the offset
     * @see AbstractStructArrayBase::offsetGet()
     * @param int $offset
     * @return \StructType\ServiceTimeTachoDetail|null
     */
    public function offsetGet($offset)
    {
        return parent::offsetGet($offset);
    }
    /**
     * Returns the attribute name
     * @see AbstractStructArrayBase::getAttributeName()
     * @return string ServiceTimeTachoDetail
     */
    public function getAttributeName()
    {
        return 'ServiceTimeTachoDetail';
    }
}
